/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.109 by jmc, Thu Dec 13 18:28:41 2007 UTC revision 1.133 by jmc, Sat Jan 16 22:08:27 2010 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mth)                   run multi threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
# Line 19  usage() Line 19  usage()
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"\" no email is sent)"      echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
26      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 28  usage() Line 30  usage()
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
32      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34      echo "  (-command) STRING        command to run"      echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
# Line 40  usage() Line 43  usage()
43      echo "                             (DEF=\"12\")"      echo "                             (DEF=\"12\")"
44      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46        echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
47      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
48      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
49      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
# Line 65  usage() Line 69  usage()
69  build_mpack()  build_mpack()
70  {  {
71      printf "building the mpack utility...  "      printf "building the mpack utility...  "
72      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
73        if test ! -x $MPACK ; then
74          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
75              echo              echo
76              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 74  build_mpack() Line 79  build_mpack()
79              echo              echo
80              HAVE_MPACK=f              HAVE_MPACK=f
81          fi          fi
         printf "building mpack...  "  
82          if test "x$CC" = x ; then          if test "x$CC" = x ; then
83              export CC=cc              export CC=cc
84          fi          fi
85            printf "building mpack (using CC=$CC)...  "
86          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
87          RETVAL=$?          RETVAL=$?
88          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 88  build_mpack() Line 93  build_mpack()
93          else          else
94              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
95              HAVE_MPACK=t              HAVE_MPACK=t
96                echo "done"
97          fi          fi
98      else      else
99          HAVE_MPACK=t          HAVE_MPACK=t
100            echo "already exist"
101      fi      fi
     echo "OK"  
102  }  }
103    
104  testoutput_var()  testoutput_var()
# Line 175  testoutput_var() Line 181  testoutput_var()
181      return $digits_of_similarity      return $digits_of_similarity
182  }  }
183    
 check_for_add_mon_output()  
 {  
     # Check for additional types of monitor output  
     if test "x$1" = x ; then  
         return  
     fi  
   
     for ii in $PTRACERS_NUM ; do  
         eval "HAVE_PTR0"$ii"=f"  
     done  
   
     ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"  
     ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"  
     for ii in $PTRACERS_NUM ; do  
         for jj in $ptr_add ; do  
             name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`  
             tst=`grep $name $1 | wc -l | awk '{print $1}'`  
             if test ! "x$tst" = x0 ; then  
                 eval "HAVE_PTR0"$ii"=t"  
             fi  
         done  
         #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'  
     done  
 }  
   
184  testoutput_run()  testoutput_run()
185  {  {
186      # testoutput_run directory subdir reference_output      # testoutput_run directory subdir reference_output
# Line 217  testoutput_run() Line 198  testoutput_run()
198          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
199                                 | sed 's/+//g' | sed "s/^$sVar//"`                                 | sed 's/+//g' | sed "s/^$sVar//"`
200          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
201          for ii in 1 2 3 4 5 6 7 8 9 ; do          # check for ptracer output in reference_output file :
202            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`          outpref=$1/results/$3
203           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
204            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
205          done          for ii in $PTRACERS_NUM ; do
206          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`              ptrfound=0
207                for jj in $ptr_mon ; do
208                    name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
209                    tst=`grep $name $outpref | wc -l | awk '{print $1}'`
210                    if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
211                done
212                if test $ptrfound = '1' ; then
213                    eval "HAVE_PTR0"$ii"=t"
214                else
215                    eval "HAVE_PTR0"$ii"=f"
216                  if test "x$ADM" = x -a "x$OADM" = x; then
217                  # remove this ptr from the list of output variable to check
218                  # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
219                    listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
220                  fi
221                fi
222            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
223            done
224            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
225          if test $tst != 1 ; then          if test $tst != 1 ; then
226            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
227                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
# Line 266  testoutput_run() Line 265  testoutput_run()
265             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
266          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
267             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
268           'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
269           'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
270           'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
271           'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
272           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
273           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
274           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
275           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
276           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
277           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
278           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
279           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
280          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
281          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
282          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
# Line 317  genmakemodel() Line 316  genmakemodel()
316          (          (
317              cd $1;              cd $1;
318              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
319              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
                 command="$command --mods=../code"  
             else  
320                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
321                elif test "x$OADM" = xt ; then
322                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
323                else
324                    command="$command -mods=../code"
325              fi              fi
326              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
327                  command="$command --optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
328              fi              fi
329              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
330                  command="$command -ieee"                  command="$command -ieee"
# Line 334  genmakemodel() Line 335  genmakemodel()
335              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
336                  command="$command -mpi"                  command="$command -mpi"
337              fi              fi
338                if test "x$MULTI_THREAD" = xt ; then
339                #- run multi-threaded using OpenMP:
340                    command="$command -omp"
341                fi
342              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
343                  command="$command -ts"                  command="$command -ts"
344              fi              fi
# Line 345  genmakemodel() Line 350  genmakemodel()
350              fi              fi
351              fi              fi
352              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
353              $command > make.log 2>&1              # $command > make.log 2>&1
354                eval $command > make.log 2>&1
355              RETVAL=$?              RETVAL=$?
356              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
357              head -100 Makefile > $CDIR/Makefile_head              head -100 Makefile > $CDIR/Makefile_head
# Line 380  makeclean() Line 386  makeclean()
386                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
387                      return 1                      return 1
388                  fi                  fi
389                    echo successful 1>&2
390                else
391                    echo ''
392              fi              fi
             echo successful 1>&2  
393              exit 0              exit 0
394          )          )
395      fi      fi
# Line 440  makemodel() Line 448  makemodel()
448          cd $1;          cd $1;
449          if test -r Makefile ; then          if test -r Makefile ; then
450              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
451              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
452                    $MAKE adall >> make.log 2>&1
453                elif test "x$OADM" = xt ; then
454                    $MAKE adAll >> make.log 2>&1
455                else
456                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
457                      $MAKE >> make.log 2>&1                      $MAKE >> make.log 2>&1
458                  else                  else
459                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.log 2>&1
460                  fi                  fi
             else  
                 $MAKE adall >> make.log 2>&1  
461              fi              fi
462              RETVAL=$?              RETVAL=$?
463              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
464                  tail make.log                  tail make.log
465                  echo failed 1>&2                  echo failed 1>&2
466                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
467                    rm -f $EXECUTABLE
468                  return 1                  return 1
469              else              else
470                  echo successful 1>&2                  echo successful 1>&2
# Line 474  symlink_mpifiles() Line 485  symlink_mpifiles()
485      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
486            
487      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
488      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
489    
490      #  Is this an MPI run?      #  Is this an MPI run?
491      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 518  linkdata() Line 529  linkdata()
529      if test -d $1 ; then      if test -d $1 ; then
530          (          (
531              cd $1 ; shift              cd $1 ; shift
532                inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
533                for xx in $inpMPI ; do
534                  if test -r "../"$1"/"$xx ; then
535                    # found 1 _mpi sfx file in 1rst input dir and it is readable
536                    yy=`echo $xx | sed 's:\.mpi$::'`
537                    if test "x$MPI" = "xt" ; then
538                    # mpi test: remove symbolic link & link _mpi sfx file
539                        if test -h $yy ; then rm -f $yy ; fi
540                        if test ! -r $yy ; then
541                            ln -sf "../"$1"/"$xx $yy ;
542                            printf "$xx " 1>&2
543                        fi
544                    else
545                    # not mpi test: remove symbolic link
546                        if test -h $yy ; then rm -f $yy ; fi
547                    fi
548                  fi
549                done
550              if test -r "../"$1"/eedata.mth" ; then              if test -r "../"$1"/eedata.mth" ; then
551              # found eedata.mth in 1rst input dir and it is readable              # found eedata.mth in 1rst input dir and it is readable
552                  if test "x$MULTI_THREAD" = "xt" ; then                  if test "x$MULTI_THREAD" = "xt" ; then
# Line 569  runmodel() Line 598  runmodel()
598          echo          echo
599          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
600              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
601              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; rm -f run.log ; fi              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
602          fi          fi
603          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
604              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
605              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
606          fi          fi
607          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
608                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
609                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
610                  echo " no executable:" $EXECUTABLE >> run.log                  echo " no executable:" $EXECUTABLE >> $RUNLOG
611                  RETVAL=8                  RETVAL=8
612                  ENDVAL=-1                  ENDVAL=-1
613          else          else
614              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
615                # output do not exist or is older than executable:                # output do not exist or is older than executable:
616                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
617                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
618                  ( eval $COMMAND ) >> run.log 2>&1                  ( eval $COMMAND ) >> $RUNLOG 2>&1
619                  RETVAL=$?                  RETVAL=$?
620              else              else
621                  RETVAL=0                  RETVAL=0
622                  if test -f run.log ; then                  if test -f $RUNLOG ; then
623                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
624                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
625                  else                  else
626                      touch run.log                      touch $RUNLOG
627                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
628                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
629                      echo " no previous run.log: assume NORMAL END" >> run.log 2>&1                      echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
630                  fi                  fi
631              fi              fi
632              ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
633          fi          fi
634          rm -f run.log_00          rm -f run.log_tmp
         #if test "x$RETVAL" = x0 ; then  
635          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
636              tail run.log              tail $RUNLOG
637              echo successful 1>&2              echo successful 1>&2
638              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
639              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
640              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
641              return 0              return 0
642            elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
643                #-- for some weird cases (run is finihed but with error code)
644                tail $RUNLOG
645                echo finished with error '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
646                return 0
647          else          else
648              tail run.log              tail $RUNLOG
649              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
650              cp run.log $CDIR"/run.log"              cp $RUNLOG $CDIR"/"$RUNLOG
651              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
652              return 1              return 1
653          fi          fi
# Line 625  createcodelet() Line 658  createcodelet()
658  {  {
659      # create codelet for comparing model output      # create codelet for comparing model output
660    
661      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
662      cat > tr_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
663  #include <stdio.h>  #include <stdio.h>
664  #include <math.h>  #include <math.h>
# Line 715  scandirs() Line 748  scandirs()
748  }  }
749    
750    
751    check_eedata()
752    {
753        # check_eedata size.h eedata
754        if [ $# -eq 2 ] ; then
755          if test -f $1 -a -f $2 ; then
756          sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
757          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
758          if test "x$nx" = x ; then
759            rx=10
760          else
761            rx=`expr $sx % $nx`
762          fi
763          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
764          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
765          if test "x$ny" = x ; then
766            ry=20
767          else
768            ry=`expr $sy % $ny`
769          fi
770          echo `expr $rx + $ry`
771        else
772          echo '-1'
773          fi
774        else
775          echo '-2'
776        fi
777    
778    }
779    
780  ###############################################################################  ###############################################################################
781    
782    
# Line 730  fi Line 792  fi
792  GSL=f  GSL=f
793    
794  CLEANUP=f  CLEANUP=f
795    NORUN=f
796  QUICK=f  QUICK=f
797  NOGENMAKE=f  NOGENMAKE=f
798  NOCLEAN=f  NOCLEAN=f
# Line 743  TESTDIRS= Line 806  TESTDIRS=
806  SKIPDIRS=  SKIPDIRS=
807  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
808  HAVE_MPACK=  HAVE_MPACK=
809  MPACK="$MPACKDIR/mpack"  MPACK=
810  COMMAND=  COMMAND=
811  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
812      MAKE=make      MAKE=make
# Line 758  OUTDIR= Line 821  OUTDIR=
821  DELDIR=  DELDIR=
822    
823  ADM=  ADM=
824    OADM=
825    
826  # Additional monitor types  # list of pTracers to check for monitor output
827  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
828    
829  MATCH_CRIT=13  MATCH_CRIT=13
# Line 792  for ac_option ; do Line 856  for ac_option ; do
856              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
857          -addr=* | --addr=*)          -addr=* | --addr=*)
858              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
859            -mpackdir | --mpackdir | -mpd | --mpd)
860                ac_prev=MPACKDIR ;;
861            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
862                MPACKDIR=$ac_optarg ;;
863    
864          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
865              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
# Line 837  for ac_option ; do Line 905  for ac_option ; do
905          -clean | --clean)          -clean | --clean)
906              CLEANUP=t ; DELDIR=t ;;              CLEANUP=t ; DELDIR=t ;;
907    
908            -norun | --norun | -nr | --nr)
909                NORUN=t ;;
910          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
911              QUICK=t ;;              QUICK=t ;;
912          -nogenmake | --nogenmake | -ng | --ng)          -nogenmake | --nogenmake | -ng | --ng)
# Line 855  for ac_option ; do Line 925  for ac_option ; do
925    
926          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
927    
928            -oad) OADM=t; NODEPEND=t ;;
929    
930          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
931          -noieee) IEEE= ;;          -noieee) IEEE= ;;
932          -gsl) GSL=t ;;          -gsl) GSL=t ;;
# Line 897  if test "x$ADM" = xt ; then Line 969  if test "x$ADM" = xt ; then
969      inputdir=input_ad      inputdir=input_ad
970      ref_outp="output_adm.txt"      ref_outp="output_adm.txt"
971      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
972    elif test "x$OADM" = xt ; then
973        code_dir=code_oad
974        inputdir=input_oad
975        ref_outp="output_oadm.txt"
976        EXECUTABLE="mitgcmuv_ad"
977  else  else
978      code_dir=code      code_dir=code
979      inputdir=input      inputdir=input
# Line 949  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 1026  if test "x$OPTFILE" = xNONE -a "x$MITGCM
1026      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
1027  fi  fi
1028    
1029    RUNLOG="run.log"
1030  OUTPUTFILE=$ref_outp  OUTPUTFILE=$ref_outp
1031  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
1032      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
# Line 963  echo "OK (COMMAND= $COMMAND )" Line 1041  echo "OK (COMMAND= $COMMAND )"
1041  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
1042  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
1043  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
1044  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1045      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1046      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1047      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
# Line 976  else Line 1054  else
1054  fi  fi
1055    
1056  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1057  createcodelet  if test -x tr_cmpnum ; then
1058        echo "skipping comparison code build"
1059    else
1060        createcodelet
1061    fi
1062    
1063  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1064  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
1065      echo "skipping mpack build"      echo "skipping mpack build"
1066  else  else
1067      build_mpack      build_mpack
1068  fi  fi
1069    
1070  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1071    CMDLINE=$0
1072    for xx in "$@" ; do nw=`echo $xx | wc -w`
1073        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1074                            else CMDLINE="$CMDLINE '$xx'" ; fi
1075    done
1076    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1077  MACH=`hostname`  MACH=`hostname`
1078  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1079  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1080  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1081  if test "x$OUTDIR" != x ; then  if test "x$OUTDIR" != x ; then
1082      BASE="tr_"$OUTDIR"_"$DATE"_"      BASE="tr_"$OUTDIR"_"$DATE"_"
1083    else
1084        short_name=`hostname | sed 's/\..*$//'`
1085        BASE="tr_"$short_name"_"$DATE"_"
1086  fi  fi
1087  DNUM=0  DNUM=0
1088  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
# Line 1006  if test "x$RETVAL" != x0 ; then Line 1097  if test "x$RETVAL" != x0 ; then
1097      exit 1      exit 1
1098  fi  fi
1099  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1100  start_date=`date`  start_date=`date`
1101  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1102    echo 'run:' $CMDLINE >> $SUMMARY
1103    echo 'on :' $UNAMEA  >> $SUMMARY
1104    
1105  of_path=  of_path=
1106  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 1037  else Line 1129  else
1129  fi  fi
1130  echo  echo
1131  echo >> $SUMMARY  echo >> $SUMMARY
1132  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1133      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1134      then line_0="default  "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1135      else line_0="default "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
# Line 1048  if test "x$ADM" = x ; then Line 1140  if test "x$ADM" = x ; then
1140      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1141      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1142      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
         #  tst=`eval 'echo $HAVE_PTR0'$ii`  
         #  if test "x$tst" = xt ; then  
1143          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
1144          line_1="$line_1        m  s"          line_1="$line_1        m  s"
1145          line_2="$line_2  m  m  e  ."          line_2="$line_2  m  m  e  ."
1146          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1147          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
         #  fi  
1148      done      done
1149      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1150      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
# Line 1094  for dir in $TESTDIRS ; do Line 1183  for dir in $TESTDIRS ; do
1183    
1184      #  Cleanup only!      #  Cleanup only!
1185      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1186          if test -r $BUILD_DIR/Makefile ; then          echo -n '  --- dir:' $BUILD_DIR ': '
1187              echo '  ------  clean dir:' $dir/build          makeclean $BUILD_DIR
1188              ( cd $BUILD_DIR ; make CLEAN )          rm -f $BUILD_DIR/$EXECUTABLE
         fi  
1189          if test -d $dir/$rundir/CVS ; then          if test -d $dir/$rundir/CVS ; then
1190              echo '  ------  clean dir:' $dir/$rundir              echo -n '  --- dir:' $dir/$rundir ': '
1191              run_clean $dir/$rundir              run_clean $dir/$rundir
1192          fi          fi
1193          (          trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1194              cd $dir          ttd=`echo $trdir | wc -w`
1195              rm -rf tr_run.*          if test $ttd != 0 ; then
1196          )              echo '  --- rm dir:' $trdir
1197                ( cd $dir ; rm -rf $trdir )
1198            fi
1199          continue          continue
1200      fi      fi
1201    
# Line 1116  for dir in $TESTDIRS ; do Line 1206  for dir in $TESTDIRS ; do
1206          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1207          continue          continue
1208      fi      fi
     if test "x$ADM" = x ; then  
         check_for_add_mon_output  $fout  
     fi  
1209    
1210      # Check for additional types of monitor output      # Check for specific files for particular type of run
1211    
1212      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1213          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
# Line 1130  for dir in $TESTDIRS ; do Line 1217  for dir in $TESTDIRS ; do
1217          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1218          continue          continue
1219      fi      fi
1220        if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1221          retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1222          if test $retv != 0 ; then
1223            echo "input/eedata.mth tiling misfit -- skipping $dir"
1224            continue
1225          fi
1226        fi
1227    
1228      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1229      extra_runs=      extra_runs=
1230      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`      if test "x$NORUN" = xf ; then
1231            ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1232        fi
1233      #echo "ex_run_dirs='$ex_run_dirs'"      #echo "ex_run_dirs='$ex_run_dirs'"
1234      for exd in $ex_run_dirs ; do      for exd in $ex_run_dirs ; do
1235          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1236          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1237          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
1238          if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1239              if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1240                  if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1241                  if test "x$MPI" = "xt" ; then
1242                    retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1243                    if test $retv = 0 ; then
1244                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1245                  #else echo $dir"/"$exd"/eedata.mth: not found"                  else
1246                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1247                  fi                  fi
1248              else                else
1249                  extra_runs="$extra_runs $name"                  extra_runs="$extra_runs $name"
1250                  fi
1251                #else echo $dir"/"$exd"/eedata.mth: not found"
1252              fi              fi
1253              else
1254                extra_runs="$extra_runs $name"
1255              fi
1256          fi          fi
1257      done      done
1258    
# Line 1167  for dir in $TESTDIRS ; do Line 1272  for dir in $TESTDIRS ; do
1272      mkdir $rel_CDIR      mkdir $rel_CDIR
1273      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$rel_CDIR"
1274            
1275      if test "x$CLEANUP" = xt ; then      if test "x$NORUN" = xt ; then
1276          echo '====>>> this is to check that we never go through this part <<< ==='              run=N
1277          makeclean $dir/$builddir \          genmakemodel $dir/$builddir && genmake=Y \
1278              && run_clean $dir/$rundir              && makeclean $dir/$builddir \
1279                && run_clean $dir/$rundir \
1280                && symlink_mpifiles $dir $code_dir $builddir \
1281                && makedependmodel $dir/$builddir && makedepend=Y \
1282                && makemodel $dir/$builddir && make=Y
1283      else      else
1284          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1285              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
# Line 1183  for dir in $TESTDIRS ; do Line 1292  for dir in $TESTDIRS ; do
1292              && results=`testoutput_run $dir $rundir $ref_outp`              && results=`testoutput_run $dir $rundir $ref_outp`
1293      fi      fi
1294            
1295        #echo "results='$results'"
1296      echo      echo
1297          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1298          echo          echo
# Line 1244  for dir in $TESTDIRS ; do Line 1354  for dir in $TESTDIRS ; do
1354  done  done
1355    
1356  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1357  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1358  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1359  date >> $SUMMARY  date >> $SUMMARY
1360    
# Line 1269  else Line 1379  else
1379              echo "An email containing results was sent to the following addresses:"              echo "An email containing results was sent to the following addresses:"
1380              echo "  \"$ADDRESSES\""              echo "  \"$ADDRESSES\""
1381              echo              echo
1382                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1383                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1384          fi          fi
         test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"  
         test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"  
1385      fi      fi
1386  fi  fi
1387    
1388  rm -f tr_cmpnum.c tr_cmpnum  if test "x$QUICK" = xf -a "x$NORUN" = xf ; then
1389        rm -f tr_cmpnum.c tr_cmpnum
1390    fi
1391    
1392  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1393      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'

Legend:
Removed from v.1.109  
changed lines
  Added in v.1.133

  ViewVC Help
Powered by ViewVC 1.1.22